import babel from '@rollup/plugin-babel';
import visualizer from 'rollup-plugin-visualizer';
import typescript from 'rollup-plugin-typescript';

import { terser } from 'rollup-plugin-terser';

import pkg from './package.json';

const getPluginsConfig = () => {
  const plugins = [
    babel({
      exclude: 'node_modules/**',
    }),
    typescript(),
    visualizer(),
    terser() /** minified */,
  ];

  return plugins;
};

export default () => {
  const bundle = {
    input: ['./src/index.ts'],
    output: [
      {
        dir: pkg.main,
      },
    ],
  };
  bundle.external = pkg.peerDependencies;
  bundle.plugins = getPluginsConfig();
  return bundle;
};
